%define with_maven  0
Name:          picocontainer
Version:       1.3
Release:       %mkrel 1
Summary:       Dependency-injection container
Group:         Development/Java
License:       BSD
URL:           http://picocontainer.codehaus.org/
# svn export http://svn.codehaus.org/picocontainer/java/1.x/picocontainer/tags/picocontainer-1_3 picocontainer-1.3
# tar czf picocontainer-1.3-src-svn.tar.gz picocontainer-1.3
Source0:       picocontainer-1.3-src-svn.tar.gz
Source1:       picocontainer-1.3-settings.xml
Source2:       picocontainer-1.3-site.xml
Source3:       picocontainer-1.3-build.xml
Source4:       picocontainer-1.3-container-build.xml
Source5:       picocontainer-1.3-distribution-build.xml
Source6:       picocontainer-1.3-gems-build.xml
Source7:       picocontainer-1.3-tck-build.xml

Patch0:        picocontainer13-1.3-pom_xml.patch
Patch1:        picocontainer13-1.3-distribution-pom_xml.patch
Patch2:        picocontainer-1.3-CommonsLoggingTracingContainerDecoratorTestCase.patch
Patch3:        picocontainer-1.3-Log4jTracingContainerDecoratorTestCase.patch
Patch4:        picocontainer-1.3-Log4jTracingContainerDecorator.patch
Patch5:        picocontainer-1.3-CommonsLoggingTracingContainerDecorator.patch

%if !%with_maven
BuildRequires: ant
BuildRequires: ant-junit
%else
BuildRequires: avalon-framework
BuildRequires: cobertura
BuildRequires: gnu-getopt
BuildRequires: jakarta-slide-webdavclient
BuildRequires: jetty5
BuildRequires: maven
BuildRequires: maven-compiler-plugin
BuildRequires: maven-dependency-plugin
BuildRequires: maven-install-plugin
BuildRequires: maven-jar-plugin
BuildRequires: maven-javadoc-plugin
BuildRequires: maven-plugin-cobertura
BuildRequires: maven-project-info-reports-plugin
BuildRequires: maven-release
BuildRequires: maven-resources-plugin
BuildRequires: maven-site-plugin
BuildRequires: maven-source-plugin
BuildRequires: maven-surefire-plugin
BuildRequires: plexus-utils
BuildRequires: servletapi5
BuildRequires: xml-commons-apis
%endif
BuildRequires: apache-commons-logging
BuildRequires: cglib21
BuildRequires: jmock1
BuildRequires: junit
BuildRequires: liblog4j-java
BuildRequires: prefuse
BuildRequires: proxytoys
BuildRequires: xpp3-minimal
BuildRequires: xstream
Requires:      apache-commons-logging
Requires:      jpackage-utils
Requires:      liblog4j-java
Requires:      proxytoys
BuildArch:     noarch
BuildRoot:     %{_tmppath}/%{name}-%{version}-root

%description
PicoContainer is a lightweight and highly embeddable container
for components that honour Dependency Injection.

%package javadoc
Group:         Development/Java
Summary:       Javadoc for %{name}
Requires:      %{name} = %{version}-%{release} 
Requires:      jpackage-utils

%description javadoc
PicoContainer - Dependency-injection container.

This package contains documentation for %{name}.

%prep

%setup -q -n picocontainer-%{version}

%patch0 -p0
%patch1 -p1
%patch2 -p0
%patch3 -p0
%patch4 -p0
%patch5 -p0

for j in $(find . -name "*.jar"); do
  mv $j ${j}.no
done

mkdir -p src/site
cp %{SOURCE2} src/site/site.xml
cp %{SOURCE3} build.xml
cp %{SOURCE4} container/build.xml
cp %{SOURCE5} distribution/build.xml
cp %{SOURCE6} gems/build.xml
cp %{SOURCE7} tck/build.xml

%build

%if %with_maven

  cp %{SOURCE1} settings.xml
  mkdir -p .m2/repository/JPP/maven2

  sed -i -e "s|<localRepository>__INTERNAL_REPO_PLACEHOLDER__</localRepository>|<localRepository>file://`pwd`/external_repo</localRepository>|g" settings.xml
  sed -i -e "s|<url>__EXTERNAL_REPO_PLACEHOLDER__</url>|<url>file://`pwd`/.m2/repository</url>|g" settings.xml

  export MAVEN_REPO_LOCAL=$(pwd)/.m2/repository
  mkdir -p $MAVEN_REPO_LOCAL

  mkdir external_repo
  ln -s %{_javadir} external_repo/JPP

  mvn-jpp \
    -e \
    -s $(pwd)/settings.xml \
    -Dmaven.test.failure.ignore=true \
    -Dmaven.repo.local=$MAVEN_REPO_LOCAL \
    install javadoc:javadoc

%else
  pushd container
    export CLASSPATH=$(build-classpath jmock1 xstream junit ant/ant-junit)
    CLASSPATH=$CLASSPATH:target/classes:target/test-classes
    ant -Dbuild.sysclasspath=only jar javadoc
  popd
  pushd tck
    export CLASSPATH=$(build-classpath jmock1 xstream junit ant/ant-junit)
    CLASSPATH=$CLASSPATH:../container/target/picocontainer-%{version}.jar
    CLASSPATH=$CLASSPATH:target/classes:target/test-classes
    ant -Dbuild.sysclasspath=only jar javadoc
  popd
  pushd gems
    export CLASSPATH=$(build-classpath proxytoys prefuse jmock1 xstream cglib21-nodep commons-logging)
        CLASSPATH=$CLASSPATH:$(build-classpath xpp3-minimal junit log4j ant/ant-junit)
    CLASSPATH=$CLASSPATH:../container/target/picocontainer-%{version}.jar
    CLASSPATH=$CLASSPATH:../tck/target/picocontainer-tck-%{version}.jar
    CLASSPATH=$CLASSPATH:target/classes:target/test-classes
    ant -Dbuild.sysclasspath=only jar javadoc
  popd
%endif

%install
[ "%{buildroot}" != / ] && rm -rf "%{buildroot}"

mkdir -p %{buildroot}%{_javadir}
install -pm 644 tck/target/picocontainer-tck-%{version}.jar \
  %{buildroot}%{_javadir}/picocontainer-tck-%{version}.jar
install -pm 644 gems/target/picocontainer-gems-%{version}.jar \
  %{buildroot}%{_javadir}/picocontainer-gems-%{version}.jar
install -pm 644 container/target/picocontainer-%{version}.jar \
  %{buildroot}%{_javadir}/picocontainer-%{version}.jar

(
  cd %{buildroot}%{_javadir}
  for jar in *-%{version}*; do
    ln -sf ${jar} ${jar/-%{version}/}
  done
)

%add_to_maven_depmap org.picocontainer picocontainer-parent %{version} JPP picocontainer-parent
%add_to_maven_depmap org.picocontainer picocontainer-distribution %{version} JPP picocontainer-distribution
%add_to_maven_depmap org.picocontainer picocontainer %{version} JPP picocontainer
%add_to_maven_depmap org.picocontainer picocontainer-tck %{version} JPP picocontainer-tck
%add_to_maven_depmap org.picocontainer picocontainer-gems %{version} JPP picocontainer-gems

mkdir -p %{buildroot}%{_mavenpomdir}
install -pm 644 pom.xml %{buildroot}%{_mavenpomdir}/JPP-picocontainer-parent.pom
install -pm 644 distribution/pom.xml %{buildroot}%{_mavenpomdir}/JPP-picocontainer-distribution.pom
install -pm 644 container/pom.xml %{buildroot}%{_mavenpomdir}/JPP-picocontainer.pom
install -pm 644 tck/pom.xml %{buildroot}%{_mavenpomdir}/JPP-picocontainer-tck.pom
install -pm 644 gems/pom.xml %{buildroot}%{_mavenpomdir}/JPP-picocontainer-gems.pom

mkdir -p %{buildroot}%{_javadocdir}/picocontainer-%{version}/tck
cp -pr tck/target/site/apidocs/* %{buildroot}%{_javadocdir}/picocontainer-%{version}/tck
mkdir -p %{buildroot}%{_javadocdir}/picocontainer-%{version}/gems
cp -pr gems/target/site/apidocs/* %{buildroot}%{_javadocdir}/picocontainer-%{version}/gems
mkdir -p %{buildroot}%{_javadocdir}/picocontainer-%{version}/container
cp -pr container/target/site/apidocs/* %{buildroot}%{_javadocdir}/picocontainer-%{version}/container
ln -s picocontainer-%{version} %{buildroot}%{_javadocdir}/picocontainer

%clean
[ "%{buildroot}" != / ] && rm -rf "%{buildroot}"

%post
%update_maven_depmap

%postun
%update_maven_depmap

%files
%defattr(-,root,root)
%{_javadir}/picocontainer-%{version}.jar
%{_javadir}/picocontainer.jar
%{_javadir}/picocontainer-gems-%{version}.jar
%{_javadir}/picocontainer-gems.jar
%{_javadir}/picocontainer-tck-%{version}.jar
%{_javadir}/picocontainer-tck.jar
%{_mavenpomdir}/*
%{_mavendepmapfragdir}/*
%doc LICENSE.txt
%if %with_maven
%doc distribution/target/site/*
%endif

%files javadoc
%defattr(-,root,root)
%{_javadocdir}/picocontainer-%{version}
%{_javadocdir}/picocontainer



%changelog
* Fri Aug 05 2011 dmorgan <dmorgan> 1.3-1.mga2
+ Revision: 131843
- Clean spec file

  + gil <gil>
    - imported package picocontainer


* Sun Jun 26 2011 gil <gil> 1.3-0.%%mkrel
- initial rpm